import{s as St,o as Mt,n as xt}from"../chunks/scheduler.182ea377.js";import{S as Dt,i as $t,g as i,s as r,r as m,A as Pt,h as d,f as s,c as n,j as b,u as f,x as p,k as S,y as t,a as c,v as h,d as g,t as _,w as v}from"../chunks/index.abf12888.js";import{T as yt}from"../chunks/Tip.230e2334.js";import{D}from"../chunks/Docstring.b0ac41bc.js";import{H as st,E as Tt}from"../chunks/EditOnGithub.9b8e78e4.js";function wt(fe){let u,O=`The algorithm and model type are decoupled. You can use either DPMSolver or DPMSolver++ for both noise
prediction and data prediction models.`;return{c(){u=i("p"),u.textContent=O},l(M){u=d(M,"P",{"data-svelte-h":!0}),p(u)!=="svelte-95n5s"&&(u.textContent=O)},m(M,ee){c(M,u,ee)},p:xt,d(M){M&&s(u)}}}function Ct(fe){let u,O,M,ee,q,he,z,ot='<code>DPMSolverMultistep</code> is a multistep scheduler from <a href="https://huggingface.co/papers/2206.00927" rel="nofollow">DPM-Solver: A Fast ODE Solver for Diffusion Probabilistic Model Sampling in Around 10 Steps</a> and <a href="https://huggingface.co/papers/2211.01095" rel="nofollow">DPM-Solver++: Fast Solver for Guided Sampling of Diffusion Probabilistic Models</a> by Cheng Lu, Yuhao Zhou, Fan Bao, Jianfei Chen, Chongxuan Li, and Jun Zhu.',ge,N,rt=`DPMSolver (and the improved version DPMSolver++) is a fast dedicated high-order solver for diffusion ODEs with convergence order guarantee. Empirically, DPMSolver sampling with only 20 steps can generate high-quality
samples, and it can generate quite good samples even in 10 steps.`,_e,k,ve,H,nt="It is recommended to set <code>solver_order</code> to 2 for guide sampling, and <code>solver_order=3</code> for unconditional sampling.",be,A,it=`Dynamic thresholding from <a href="https://huggingface.co/papers/2205.11487" rel="nofollow">Imagen</a> is supported, and for pixel-space
diffusion models, you can set both <code>algorithm_type=&quot;dpmsolver++&quot;</code> and <code>thresholding=True</code> to use the dynamic
thresholding. This thresholding method is unsuitable for latent-space diffusion models such as
Stable Diffusion.`,Se,F,dt="The SDE variant of DPMSolver and DPM-Solver++ is also supported, but only for the first and second-order solvers. This is a fast SDE solver for the reverse diffusion SDE. It is recommended to use the second-order <code>sde-dpmsolver++</code>.",Me,V,xe,l,W,Ne,te,lt="<code>DPMSolverMultistepScheduler</code> is a fast dedicated high-order solver for diffusion ODEs.",ke,se,at=`This model inherits from <a href="/docs/diffusers/v0.28.2/en/api/schedulers/overview#diffusers.SchedulerMixin">SchedulerMixin</a> and <a href="/docs/diffusers/v0.28.2/en/api/configuration#diffusers.ConfigMixin">ConfigMixin</a>. Check the superclass documentation for the generic
methods the library implements for all schedulers such as loading and saving.`,He,x,j,Ae,oe,ct=`Convert the model output to the corresponding type the DPMSolver/DPMSolver++ algorithm needs. DPM-Solver is
designed to discretize an integral of the noise prediction model, and DPM-Solver++ is designed to discretize an
integral of the data prediction model.`,Fe,P,Ve,y,G,We,re,pt="One step for the first-order DPMSolver (equivalent to DDIM).",je,T,R,Ge,ne,ut="One step for the second-order multistep DPMSolver.",Re,w,U,Ue,ie,mt="One step for the third-order multistep DPMSolver.",Be,C,B,Je,de,ft=`Ensures interchangeability with schedulers that need to scale the denoising model input depending on the
current timestep.`,Ye,L,J,Ze,le,ht="Sets the begin index for the scheduler. This function should be run from pipeline before the inference.",Ke,E,Y,Qe,ae,gt="Sets the discrete timesteps used for the diffusion chain (to be run before inference).",Xe,I,Z,et,ce,_t=`Predict the sample from the previous timestep by reversing the SDE. This function propagates the sample with
the multistep DPMSolver.`,De,K,vt="## SchedulerOutput[[diffusers.schedulers.scheduling_utils.SchedulerOutput]]",$e,$,Q,tt,pe,bt="Base class for the output of a scheduler’s <code>step</code> function.",Pe,X,ye,me,Te;return q=new st({props:{title:"DPMSolverMultistepScheduler",local:"dpmsolvermultistepscheduler",headingTag:"h1"}}),k=new st({props:{title:"Tips",local:"tips",headingTag:"h2"}}),V=new st({props:{title:"DPMSolverMultistepScheduler",local:"diffusers.DPMSolverMultistepScheduler",headingTag:"h2"}}),W=new D({props:{name:"class diffusers.DPMSolverMultistepScheduler",anchor:"diffusers.DPMSolverMultistepScheduler",parameters:[{name:"num_train_timesteps",val:": int = 1000"},{name:"beta_start",val:": float = 0.0001"},{name:"beta_end",val:": float = 0.02"},{name:"beta_schedule",val:": str = 'linear'"},{name:"trained_betas",val:": Union = None"},{name:"solver_order",val:": int = 2"},{name:"prediction_type",val:": str = 'epsilon'"},{name:"thresholding",val:": bool = False"},{name:"dynamic_thresholding_ratio",val:": float = 0.995"},{name:"sample_max_value",val:": float = 1.0"},{name:"algorithm_type",val:": str = 'dpmsolver++'"},{name:"solver_type",val:": str = 'midpoint'"},{name:"lower_order_final",val:": bool = True"},{name:"euler_at_final",val:": bool = False"},{name:"use_karras_sigmas",val:": Optional = False"},{name:"use_lu_lambdas",val:": Optional = False"},{name:"final_sigmas_type",val:": Optional = 'zero'"},{name:"lambda_min_clipped",val:": float = -inf"},{name:"variance_type",val:": Optional = None"},{name:"timestep_spacing",val:": str = 'linspace'"},{name:"steps_offset",val:": int = 0"},{name:"rescale_betas_zero_snr",val:": bool = False"}],parametersDescription:[{anchor:"diffusers.DPMSolverMultistepScheduler.num_train_timesteps",description:`<strong>num_train_timesteps</strong> (<code>int</code>, defaults to 1000) &#x2014;
The number of diffusion steps to train the model.`,name:"num_train_timesteps"},{anchor:"diffusers.DPMSolverMultistepScheduler.beta_start",description:`<strong>beta_start</strong> (<code>float</code>, defaults to 0.0001) &#x2014;
The starting <code>beta</code> value of inference.`,name:"beta_start"},{anchor:"diffusers.DPMSolverMultistepScheduler.beta_end",description:`<strong>beta_end</strong> (<code>float</code>, defaults to 0.02) &#x2014;
The final <code>beta</code> value.`,name:"beta_end"},{anchor:"diffusers.DPMSolverMultistepScheduler.beta_schedule",description:`<strong>beta_schedule</strong> (<code>str</code>, defaults to <code>&quot;linear&quot;</code>) &#x2014;
The beta schedule, a mapping from a beta range to a sequence of betas for stepping the model. Choose from
<code>linear</code>, <code>scaled_linear</code>, or <code>squaredcos_cap_v2</code>.`,name:"beta_schedule"},{anchor:"diffusers.DPMSolverMultistepScheduler.trained_betas",description:`<strong>trained_betas</strong> (<code>np.ndarray</code>, <em>optional</em>) &#x2014;
Pass an array of betas directly to the constructor to bypass <code>beta_start</code> and <code>beta_end</code>.`,name:"trained_betas"},{anchor:"diffusers.DPMSolverMultistepScheduler.solver_order",description:`<strong>solver_order</strong> (<code>int</code>, defaults to 2) &#x2014;
The DPMSolver order which can be <code>1</code> or <code>2</code> or <code>3</code>. It is recommended to use <code>solver_order=2</code> for guided
sampling, and <code>solver_order=3</code> for unconditional sampling.`,name:"solver_order"},{anchor:"diffusers.DPMSolverMultistepScheduler.prediction_type",description:`<strong>prediction_type</strong> (<code>str</code>, defaults to <code>epsilon</code>, <em>optional</em>) &#x2014;
Prediction type of the scheduler function; can be <code>epsilon</code> (predicts the noise of the diffusion process),
<code>sample</code> (directly predicts the noisy sample<code>) or </code>v_prediction\` (see section 2.4 of <a href="https://imagen.research.google/video/paper.pdf" rel="nofollow">Imagen
Video</a> paper).`,name:"prediction_type"},{anchor:"diffusers.DPMSolverMultistepScheduler.thresholding",description:`<strong>thresholding</strong> (<code>bool</code>, defaults to <code>False</code>) &#x2014;
Whether to use the &#x201C;dynamic thresholding&#x201D; method. This is unsuitable for latent-space diffusion models such
as Stable Diffusion.`,name:"thresholding"},{anchor:"diffusers.DPMSolverMultistepScheduler.dynamic_thresholding_ratio",description:`<strong>dynamic_thresholding_ratio</strong> (<code>float</code>, defaults to 0.995) &#x2014;
The ratio for the dynamic thresholding method. Valid only when <code>thresholding=True</code>.`,name:"dynamic_thresholding_ratio"},{anchor:"diffusers.DPMSolverMultistepScheduler.sample_max_value",description:`<strong>sample_max_value</strong> (<code>float</code>, defaults to 1.0) &#x2014;
The threshold value for dynamic thresholding. Valid only when <code>thresholding=True</code> and
<code>algorithm_type=&quot;dpmsolver++&quot;</code>.`,name:"sample_max_value"},{anchor:"diffusers.DPMSolverMultistepScheduler.algorithm_type",description:`<strong>algorithm_type</strong> (<code>str</code>, defaults to <code>dpmsolver++</code>) &#x2014;
Algorithm type for the solver; can be <code>dpmsolver</code>, <code>dpmsolver++</code>, <code>sde-dpmsolver</code> or <code>sde-dpmsolver++</code>. The
<code>dpmsolver</code> type implements the algorithms in the <a href="https://huggingface.co/papers/2206.00927" rel="nofollow">DPMSolver</a>
paper, and the <code>dpmsolver++</code> type implements the algorithms in the
<a href="https://huggingface.co/papers/2211.01095" rel="nofollow">DPMSolver++</a> paper. It is recommended to use <code>dpmsolver++</code> or
<code>sde-dpmsolver++</code> with <code>solver_order=2</code> for guided sampling like in Stable Diffusion.`,name:"algorithm_type"},{anchor:"diffusers.DPMSolverMultistepScheduler.solver_type",description:`<strong>solver_type</strong> (<code>str</code>, defaults to <code>midpoint</code>) &#x2014;
Solver type for the second-order solver; can be <code>midpoint</code> or <code>heun</code>. The solver type slightly affects the
sample quality, especially for a small number of steps. It is recommended to use <code>midpoint</code> solvers.`,name:"solver_type"},{anchor:"diffusers.DPMSolverMultistepScheduler.lower_order_final",description:`<strong>lower_order_final</strong> (<code>bool</code>, defaults to <code>True</code>) &#x2014;
Whether to use lower-order solvers in the final steps. Only valid for &lt; 15 inference steps. This can
stabilize the sampling of DPMSolver for steps &lt; 15, especially for steps &lt;= 10.`,name:"lower_order_final"},{anchor:"diffusers.DPMSolverMultistepScheduler.euler_at_final",description:`<strong>euler_at_final</strong> (<code>bool</code>, defaults to <code>False</code>) &#x2014;
Whether to use Euler&#x2019;s method in the final step. It is a trade-off between numerical stability and detail
richness. This can stabilize the sampling of the SDE variant of DPMSolver for small number of inference
steps, but sometimes may result in blurring.`,name:"euler_at_final"},{anchor:"diffusers.DPMSolverMultistepScheduler.use_karras_sigmas",description:`<strong>use_karras_sigmas</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether to use Karras sigmas for step sizes in the noise schedule during the sampling process. If <code>True</code>,
the sigmas are determined according to a sequence of noise levels {&#x3C3;i}.`,name:"use_karras_sigmas"},{anchor:"diffusers.DPMSolverMultistepScheduler.use_lu_lambdas",description:`<strong>use_lu_lambdas</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether to use the uniform-logSNR for step sizes proposed by Lu&#x2019;s DPM-Solver in the noise schedule during
the sampling process. If <code>True</code>, the sigmas and time steps are determined according to a sequence of
<code>lambda(t)</code>.`,name:"use_lu_lambdas"},{anchor:"diffusers.DPMSolverMultistepScheduler.final_sigmas_type",description:`<strong>final_sigmas_type</strong> (<code>str</code>, defaults to <code>&quot;zero&quot;</code>) &#x2014;
The final <code>sigma</code> value for the noise schedule during the sampling process. If <code>&quot;sigma_min&quot;</code>, the final
sigma is the same as the last sigma in the training schedule. If <code>zero</code>, the final sigma is set to 0.`,name:"final_sigmas_type"},{anchor:"diffusers.DPMSolverMultistepScheduler.lambda_min_clipped",description:`<strong>lambda_min_clipped</strong> (<code>float</code>, defaults to <code>-inf</code>) &#x2014;
Clipping threshold for the minimum value of <code>lambda(t)</code> for numerical stability. This is critical for the
cosine (<code>squaredcos_cap_v2</code>) noise schedule.`,name:"lambda_min_clipped"},{anchor:"diffusers.DPMSolverMultistepScheduler.variance_type",description:`<strong>variance_type</strong> (<code>str</code>, <em>optional</em>) &#x2014;
Set to &#x201C;learned&#x201D; or &#x201C;learned_range&#x201D; for diffusion models that predict variance. If set, the model&#x2019;s output
contains the predicted Gaussian variance.`,name:"variance_type"},{anchor:"diffusers.DPMSolverMultistepScheduler.timestep_spacing",description:`<strong>timestep_spacing</strong> (<code>str</code>, defaults to <code>&quot;linspace&quot;</code>) &#x2014;
The way the timesteps should be scaled. Refer to Table 2 of the <a href="https://huggingface.co/papers/2305.08891" rel="nofollow">Common Diffusion Noise Schedules and
Sample Steps are Flawed</a> for more information.`,name:"timestep_spacing"},{anchor:"diffusers.DPMSolverMultistepScheduler.steps_offset",description:`<strong>steps_offset</strong> (<code>int</code>, defaults to 0) &#x2014;
An offset added to the inference steps, as required by some model families.`,name:"steps_offset"},{anchor:"diffusers.DPMSolverMultistepScheduler.rescale_betas_zero_snr",description:`<strong>rescale_betas_zero_snr</strong> (<code>bool</code>, defaults to <code>False</code>) &#x2014;
Whether to rescale the betas to have zero terminal SNR. This enables the model to generate very bright and
dark samples instead of limiting it to samples with medium brightness. Loosely related to
<a href="https://github.com/huggingface/diffusers/blob/74fd735eb073eb1d774b1ab4154a0876eb82f055/examples/dreambooth/train_dreambooth.py#L506" rel="nofollow"><code>--offset_noise</code></a>.`,name:"rescale_betas_zero_snr"}],source:"https://github.com/huggingface/diffusers/blob/v0.28.2/src/diffusers/schedulers/scheduling_dpmsolver_multistep.py#L111"}}),j=new D({props:{name:"convert_model_output",anchor:"diffusers.DPMSolverMultistepScheduler.convert_model_output",parameters:[{name:"model_output",val:": Tensor"},{name:"*args",val:""},{name:"sample",val:": Tensor = None"},{name:"**kwargs",val:""}],parametersDescription:[{anchor:"diffusers.DPMSolverMultistepScheduler.convert_model_output.model_output",description:`<strong>model_output</strong> (<code>torch.Tensor</code>) &#x2014;
The direct output from the learned diffusion model.`,name:"model_output"},{anchor:"diffusers.DPMSolverMultistepScheduler.convert_model_output.sample",description:`<strong>sample</strong> (<code>torch.Tensor</code>) &#x2014;
A current instance of a sample created by the diffusion process.`,name:"sample"}],source:"https://github.com/huggingface/diffusers/blob/v0.28.2/src/diffusers/schedulers/scheduling_dpmsolver_multistep.py#L513",returnDescription:`<script context="module">export const metadata = 'undefined';<\/script>


<p>The converted model output.</p>
`,returnType:`<script context="module">export const metadata = 'undefined';<\/script>


<p><code>torch.Tensor</code></p>
`}}),P=new yt({props:{$$slots:{default:[wt]},$$scope:{ctx:fe}}}),G=new D({props:{name:"dpm_solver_first_order_update",anchor:"diffusers.DPMSolverMultistepScheduler.dpm_solver_first_order_update",parameters:[{name:"model_output",val:": Tensor"},{name:"*args",val:""},{name:"sample",val:": Tensor = None"},{name:"noise",val:": Optional = None"},{name:"**kwargs",val:""}],parametersDescription:[{anchor:"diffusers.DPMSolverMultistepScheduler.dpm_solver_first_order_update.model_output",description:`<strong>model_output</strong> (<code>torch.Tensor</code>) &#x2014;
The direct output from the learned diffusion model.`,name:"model_output"},{anchor:"diffusers.DPMSolverMultistepScheduler.dpm_solver_first_order_update.sample",description:`<strong>sample</strong> (<code>torch.Tensor</code>) &#x2014;
A current instance of a sample created by the diffusion process.`,name:"sample"}],source:"https://github.com/huggingface/diffusers/blob/v0.28.2/src/diffusers/schedulers/scheduling_dpmsolver_multistep.py#L612",returnDescription:`<script context="module">export const metadata = 'undefined';<\/script>


<p>The sample tensor at the previous timestep.</p>
`,returnType:`<script context="module">export const metadata = 'undefined';<\/script>


<p><code>torch.Tensor</code></p>
`}}),R=new D({props:{name:"multistep_dpm_solver_second_order_update",anchor:"diffusers.DPMSolverMultistepScheduler.multistep_dpm_solver_second_order_update",parameters:[{name:"model_output_list",val:": List"},{name:"*args",val:""},{name:"sample",val:": Tensor = None"},{name:"noise",val:": Optional = None"},{name:"**kwargs",val:""}],parametersDescription:[{anchor:"diffusers.DPMSolverMultistepScheduler.multistep_dpm_solver_second_order_update.model_output_list",description:`<strong>model_output_list</strong> (<code>List[torch.Tensor]</code>) &#x2014;
The direct outputs from learned diffusion model at current and latter timesteps.`,name:"model_output_list"},{anchor:"diffusers.DPMSolverMultistepScheduler.multistep_dpm_solver_second_order_update.sample",description:`<strong>sample</strong> (<code>torch.Tensor</code>) &#x2014;
A current instance of a sample created by the diffusion process.`,name:"sample"}],source:"https://github.com/huggingface/diffusers/blob/v0.28.2/src/diffusers/schedulers/scheduling_dpmsolver_multistep.py#L681",returnDescription:`<script context="module">export const metadata = 'undefined';<\/script>


<p>The sample tensor at the previous timestep.</p>
`,returnType:`<script context="module">export const metadata = 'undefined';<\/script>


<p><code>torch.Tensor</code></p>
`}}),U=new D({props:{name:"multistep_dpm_solver_third_order_update",anchor:"diffusers.DPMSolverMultistepScheduler.multistep_dpm_solver_third_order_update",parameters:[{name:"model_output_list",val:": List"},{name:"*args",val:""},{name:"sample",val:": Tensor = None"},{name:"**kwargs",val:""}],parametersDescription:[{anchor:"diffusers.DPMSolverMultistepScheduler.multistep_dpm_solver_third_order_update.model_output_list",description:`<strong>model_output_list</strong> (<code>List[torch.Tensor]</code>) &#x2014;
The direct outputs from learned diffusion model at current and latter timesteps.`,name:"model_output_list"},{anchor:"diffusers.DPMSolverMultistepScheduler.multistep_dpm_solver_third_order_update.sample",description:`<strong>sample</strong> (<code>torch.Tensor</code>) &#x2014;
A current instance of a sample created by diffusion process.`,name:"sample"}],source:"https://github.com/huggingface/diffusers/blob/v0.28.2/src/diffusers/schedulers/scheduling_dpmsolver_multistep.py#L804",returnDescription:`<script context="module">export const metadata = 'undefined';<\/script>


<p>The sample tensor at the previous timestep.</p>
`,returnType:`<script context="module">export const metadata = 'undefined';<\/script>


<p><code>torch.Tensor</code></p>
`}}),B=new D({props:{name:"scale_model_input",anchor:"diffusers.DPMSolverMultistepScheduler.scale_model_input",parameters:[{name:"sample",val:": Tensor"},{name:"*args",val:""},{name:"**kwargs",val:""}],parametersDescription:[{anchor:"diffusers.DPMSolverMultistepScheduler.scale_model_input.sample",description:`<strong>sample</strong> (<code>torch.Tensor</code>) &#x2014;
The input sample.`,name:"sample"}],source:"https://github.com/huggingface/diffusers/blob/v0.28.2/src/diffusers/schedulers/scheduling_dpmsolver_multistep.py#L1009",returnDescription:`<script context="module">export const metadata = 'undefined';<\/script>


<p>A scaled input sample.</p>
`,returnType:`<script context="module">export const metadata = 'undefined';<\/script>


<p><code>torch.Tensor</code></p>
`}}),J=new D({props:{name:"set_begin_index",anchor:"diffusers.DPMSolverMultistepScheduler.set_begin_index",parameters:[{name:"begin_index",val:": int = 0"}],parametersDescription:[{anchor:"diffusers.DPMSolverMultistepScheduler.set_begin_index.begin_index",description:`<strong>begin_index</strong> (<code>int</code>) &#x2014;
The begin index for the scheduler.`,name:"begin_index"}],source:"https://github.com/huggingface/diffusers/blob/v0.28.2/src/diffusers/schedulers/scheduling_dpmsolver_multistep.py#L296"}}),Y=new D({props:{name:"set_timesteps",anchor:"diffusers.DPMSolverMultistepScheduler.set_timesteps",parameters:[{name:"num_inference_steps",val:": int = None"},{name:"device",val:": Union = None"},{name:"timesteps",val:": Optional = None"}],parametersDescription:[{anchor:"diffusers.DPMSolverMultistepScheduler.set_timesteps.num_inference_steps",description:`<strong>num_inference_steps</strong> (<code>int</code>) &#x2014;
The number of diffusion steps used when generating samples with a pre-trained model.`,name:"num_inference_steps"},{anchor:"diffusers.DPMSolverMultistepScheduler.set_timesteps.device",description:`<strong>device</strong> (<code>str</code> or <code>torch.device</code>, <em>optional</em>) &#x2014;
The device to which the timesteps should be moved to. If <code>None</code>, the timesteps are not moved.`,name:"device"},{anchor:"diffusers.DPMSolverMultistepScheduler.set_timesteps.timesteps",description:`<strong>timesteps</strong> (<code>List[int]</code>, <em>optional</em>) &#x2014;
Custom timesteps used to support arbitrary timesteps schedule. If <code>None</code>, timesteps will be generated
based on the <code>timestep_spacing</code> attribute. If <code>timesteps</code> is passed, <code>num_inference_steps</code> and <code>sigmas</code>
must be <code>None</code>, and <code>timestep_spacing</code> attribute will be ignored.`,name:"timesteps"}],source:"https://github.com/huggingface/diffusers/blob/v0.28.2/src/diffusers/schedulers/scheduling_dpmsolver_multistep.py#L306"}}),Z=new D({props:{name:"step",anchor:"diffusers.DPMSolverMultistepScheduler.step",parameters:[{name:"model_output",val:": Tensor"},{name:"timestep",val:": int"},{name:"sample",val:": Tensor"},{name:"generator",val:" = None"},{name:"variance_noise",val:": Optional = None"},{name:"return_dict",val:": bool = True"}],parametersDescription:[{anchor:"diffusers.DPMSolverMultistepScheduler.step.model_output",description:`<strong>model_output</strong> (<code>torch.Tensor</code>) &#x2014;
The direct output from learned diffusion model.`,name:"model_output"},{anchor:"diffusers.DPMSolverMultistepScheduler.step.timestep",description:`<strong>timestep</strong> (<code>int</code>) &#x2014;
The current discrete timestep in the diffusion chain.`,name:"timestep"},{anchor:"diffusers.DPMSolverMultistepScheduler.step.sample",description:`<strong>sample</strong> (<code>torch.Tensor</code>) &#x2014;
A current instance of a sample created by the diffusion process.`,name:"sample"},{anchor:"diffusers.DPMSolverMultistepScheduler.step.generator",description:`<strong>generator</strong> (<code>torch.Generator</code>, <em>optional</em>) &#x2014;
A random number generator.`,name:"generator"},{anchor:"diffusers.DPMSolverMultistepScheduler.step.variance_noise",description:`<strong>variance_noise</strong> (<code>torch.Tensor</code>) &#x2014;
Alternative to generating noise with <code>generator</code> by directly providing the noise for the variance
itself. Useful for methods such as <code>LEdits++</code>.`,name:"variance_noise"},{anchor:"diffusers.DPMSolverMultistepScheduler.step.return_dict",description:`<strong>return_dict</strong> (<code>bool</code>) &#x2014;
Whether or not to return a <a href="/docs/diffusers/v0.28.2/en/api/schedulers/multistep_dpm_solver#diffusers.schedulers.scheduling_utils.SchedulerOutput">SchedulerOutput</a> or <code>tuple</code>.`,name:"return_dict"}],source:"https://github.com/huggingface/diffusers/blob/v0.28.2/src/diffusers/schedulers/scheduling_dpmsolver_multistep.py#L920",returnDescription:`<script context="module">export const metadata = 'undefined';<\/script>


<p>If return_dict is <code>True</code>, <a
  href="/docs/diffusers/v0.28.2/en/api/schedulers/multistep_dpm_solver#diffusers.schedulers.scheduling_utils.SchedulerOutput"
>SchedulerOutput</a> is returned, otherwise a
tuple is returned where the first element is the sample tensor.</p>
`,returnType:`<script context="module">export const metadata = 'undefined';<\/script>


<p><a
  href="/docs/diffusers/v0.28.2/en/api/schedulers/multistep_dpm_solver#diffusers.schedulers.scheduling_utils.SchedulerOutput"
>SchedulerOutput</a> or <code>tuple</code></p>
`}}),Q=new D({props:{name:"class diffusers.schedulers.scheduling_utils.SchedulerOutput",anchor:"diffusers.schedulers.scheduling_utils.SchedulerOutput",parameters:[{name:"prev_sample",val:": Tensor"}],parametersDescription:[{anchor:"diffusers.schedulers.scheduling_utils.SchedulerOutput.prev_sample",description:`<strong>prev_sample</strong> (<code>torch.Tensor</code> of shape <code>(batch_size, num_channels, height, width)</code> for images) &#x2014;
Computed sample <code>(x_{t-1})</code> of previous timestep. <code>prev_sample</code> should be used as next model input in the
denoising loop.`,name:"prev_sample"}],source:"https://github.com/huggingface/diffusers/blob/v0.28.2/src/diffusers/schedulers/scheduling_utils.py#L60"}}),X=new Tt({props:{source:"https://github.com/huggingface/diffusers/blob/main/docs/source/en/api/schedulers/multistep_dpm_solver.md"}}),{c(){u=i("meta"),O=r(),M=i("p"),ee=r(),m(q.$$.fragment),he=r(),z=i("p"),z.innerHTML=ot,ge=r(),N=i("p"),N.textContent=rt,_e=r(),m(k.$$.fragment),ve=r(),H=i("p"),H.innerHTML=nt,be=r(),A=i("p"),A.innerHTML=it,Se=r(),F=i("p"),F.innerHTML=dt,Me=r(),m(V.$$.fragment),xe=r(),l=i("div"),m(W.$$.fragment),Ne=r(),te=i("p"),te.innerHTML=lt,ke=r(),se=i("p"),se.innerHTML=at,He=r(),x=i("div"),m(j.$$.fragment),Ae=r(),oe=i("p"),oe.textContent=ct,Fe=r(),m(P.$$.fragment),Ve=r(),y=i("div"),m(G.$$.fragment),We=r(),re=i("p"),re.textContent=pt,je=r(),T=i("div"),m(R.$$.fragment),Ge=r(),ne=i("p"),ne.textContent=ut,Re=r(),w=i("div"),m(U.$$.fragment),Ue=r(),ie=i("p"),ie.textContent=mt,Be=r(),C=i("div"),m(B.$$.fragment),Je=r(),de=i("p"),de.textContent=ft,Ye=r(),L=i("div"),m(J.$$.fragment),Ze=r(),le=i("p"),le.textContent=ht,Ke=r(),E=i("div"),m(Y.$$.fragment),Qe=r(),ae=i("p"),ae.textContent=gt,Xe=r(),I=i("div"),m(Z.$$.fragment),et=r(),ce=i("p"),ce.textContent=_t,De=r(),K=i("p"),K.textContent=vt,$e=r(),$=i("div"),m(Q.$$.fragment),tt=r(),pe=i("p"),pe.innerHTML=bt,Pe=r(),m(X.$$.fragment),ye=r(),me=i("p"),this.h()},l(e){const o=Pt("svelte-u9bgzb",document.head);u=d(o,"META",{name:!0,content:!0}),o.forEach(s),O=n(e),M=d(e,"P",{}),b(M).forEach(s),ee=n(e),f(q.$$.fragment,e),he=n(e),z=d(e,"P",{"data-svelte-h":!0}),p(z)!=="svelte-zo5ht"&&(z.innerHTML=ot),ge=n(e),N=d(e,"P",{"data-svelte-h":!0}),p(N)!=="svelte-l6rv24"&&(N.textContent=rt),_e=n(e),f(k.$$.fragment,e),ve=n(e),H=d(e,"P",{"data-svelte-h":!0}),p(H)!=="svelte-pt2glg"&&(H.innerHTML=nt),be=n(e),A=d(e,"P",{"data-svelte-h":!0}),p(A)!=="svelte-1ng0gyl"&&(A.innerHTML=it),Se=n(e),F=d(e,"P",{"data-svelte-h":!0}),p(F)!=="svelte-18n28n2"&&(F.innerHTML=dt),Me=n(e),f(V.$$.fragment,e),xe=n(e),l=d(e,"DIV",{class:!0});var a=b(l);f(W.$$.fragment,a),Ne=n(a),te=d(a,"P",{"data-svelte-h":!0}),p(te)!=="svelte-12v1qo2"&&(te.innerHTML=lt),ke=n(a),se=d(a,"P",{"data-svelte-h":!0}),p(se)!=="svelte-5jztmt"&&(se.innerHTML=at),He=n(a),x=d(a,"DIV",{class:!0});var ue=b(x);f(j.$$.fragment,ue),Ae=n(ue),oe=d(ue,"P",{"data-svelte-h":!0}),p(oe)!=="svelte-1st02i8"&&(oe.textContent=ct),Fe=n(ue),f(P.$$.fragment,ue),ue.forEach(s),Ve=n(a),y=d(a,"DIV",{class:!0});var we=b(y);f(G.$$.fragment,we),We=n(we),re=d(we,"P",{"data-svelte-h":!0}),p(re)!=="svelte-4nw43d"&&(re.textContent=pt),we.forEach(s),je=n(a),T=d(a,"DIV",{class:!0});var Ce=b(T);f(R.$$.fragment,Ce),Ge=n(Ce),ne=d(Ce,"P",{"data-svelte-h":!0}),p(ne)!=="svelte-1d6o6zu"&&(ne.textContent=ut),Ce.forEach(s),Re=n(a),w=d(a,"DIV",{class:!0});var Le=b(w);f(U.$$.fragment,Le),Ue=n(Le),ie=d(Le,"P",{"data-svelte-h":!0}),p(ie)!=="svelte-17nne8p"&&(ie.textContent=mt),Le.forEach(s),Be=n(a),C=d(a,"DIV",{class:!0});var Ee=b(C);f(B.$$.fragment,Ee),Je=n(Ee),de=d(Ee,"P",{"data-svelte-h":!0}),p(de)!=="svelte-1rkfgpx"&&(de.textContent=ft),Ee.forEach(s),Ye=n(a),L=d(a,"DIV",{class:!0});var Ie=b(L);f(J.$$.fragment,Ie),Ze=n(Ie),le=d(Ie,"P",{"data-svelte-h":!0}),p(le)!=="svelte-1k141rk"&&(le.textContent=ht),Ie.forEach(s),Ke=n(a),E=d(a,"DIV",{class:!0});var Oe=b(E);f(Y.$$.fragment,Oe),Qe=n(Oe),ae=d(Oe,"P",{"data-svelte-h":!0}),p(ae)!=="svelte-1vzm9q"&&(ae.textContent=gt),Oe.forEach(s),Xe=n(a),I=d(a,"DIV",{class:!0});var qe=b(I);f(Z.$$.fragment,qe),et=n(qe),ce=d(qe,"P",{"data-svelte-h":!0}),p(ce)!=="svelte-7jbjgx"&&(ce.textContent=_t),qe.forEach(s),a.forEach(s),De=n(e),K=d(e,"P",{"data-svelte-h":!0}),p(K)!=="svelte-jslqpb"&&(K.textContent=vt),$e=n(e),$=d(e,"DIV",{class:!0});var ze=b($);f(Q.$$.fragment,ze),tt=n(ze),pe=d(ze,"P",{"data-svelte-h":!0}),p(pe)!=="svelte-6ojmkw"&&(pe.innerHTML=bt),ze.forEach(s),Pe=n(e),f(X.$$.fragment,e),ye=n(e),me=d(e,"P",{}),b(me).forEach(s),this.h()},h(){S(u,"name","hf:doc:metadata"),S(u,"content",Lt),S(x,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),S(y,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),S(T,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),S(w,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),S(C,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),S(L,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),S(E,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),S(I,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),S(l,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),S($,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8")},m(e,o){t(document.head,u),c(e,O,o),c(e,M,o),c(e,ee,o),h(q,e,o),c(e,he,o),c(e,z,o),c(e,ge,o),c(e,N,o),c(e,_e,o),h(k,e,o),c(e,ve,o),c(e,H,o),c(e,be,o),c(e,A,o),c(e,Se,o),c(e,F,o),c(e,Me,o),h(V,e,o),c(e,xe,o),c(e,l,o),h(W,l,null),t(l,Ne),t(l,te),t(l,ke),t(l,se),t(l,He),t(l,x),h(j,x,null),t(x,Ae),t(x,oe),t(x,Fe),h(P,x,null),t(l,Ve),t(l,y),h(G,y,null),t(y,We),t(y,re),t(l,je),t(l,T),h(R,T,null),t(T,Ge),t(T,ne),t(l,Re),t(l,w),h(U,w,null),t(w,Ue),t(w,ie),t(l,Be),t(l,C),h(B,C,null),t(C,Je),t(C,de),t(l,Ye),t(l,L),h(J,L,null),t(L,Ze),t(L,le),t(l,Ke),t(l,E),h(Y,E,null),t(E,Qe),t(E,ae),t(l,Xe),t(l,I),h(Z,I,null),t(I,et),t(I,ce),c(e,De,o),c(e,K,o),c(e,$e,o),c(e,$,o),h(Q,$,null),t($,tt),t($,pe),c(e,Pe,o),h(X,e,o),c(e,ye,o),c(e,me,o),Te=!0},p(e,[o]){const a={};o&2&&(a.$$scope={dirty:o,ctx:e}),P.$set(a)},i(e){Te||(g(q.$$.fragment,e),g(k.$$.fragment,e),g(V.$$.fragment,e),g(W.$$.fragment,e),g(j.$$.fragment,e),g(P.$$.fragment,e),g(G.$$.fragment,e),g(R.$$.fragment,e),g(U.$$.fragment,e),g(B.$$.fragment,e),g(J.$$.fragment,e),g(Y.$$.fragment,e),g(Z.$$.fragment,e),g(Q.$$.fragment,e),g(X.$$.fragment,e),Te=!0)},o(e){_(q.$$.fragment,e),_(k.$$.fragment,e),_(V.$$.fragment,e),_(W.$$.fragment,e),_(j.$$.fragment,e),_(P.$$.fragment,e),_(G.$$.fragment,e),_(R.$$.fragment,e),_(U.$$.fragment,e),_(B.$$.fragment,e),_(J.$$.fragment,e),_(Y.$$.fragment,e),_(Z.$$.fragment,e),_(Q.$$.fragment,e),_(X.$$.fragment,e),Te=!1},d(e){e&&(s(O),s(M),s(ee),s(he),s(z),s(ge),s(N),s(_e),s(ve),s(H),s(be),s(A),s(Se),s(F),s(Me),s(xe),s(l),s(De),s(K),s($e),s($),s(Pe),s(ye),s(me)),s(u),v(q,e),v(k,e),v(V,e),v(W),v(j),v(P),v(G),v(R),v(U),v(B),v(J),v(Y),v(Z),v(Q),v(X,e)}}}const Lt='{"title":"DPMSolverMultistepScheduler","local":"dpmsolvermultistepscheduler","sections":[{"title":"Tips","local":"tips","sections":[],"depth":2},{"title":"DPMSolverMultistepScheduler","local":"diffusers.DPMSolverMultistepScheduler","sections":[],"depth":2}],"depth":1}';function Et(fe){return Mt(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class kt extends Dt{constructor(u){super(),$t(this,u,Et,Ct,St,{})}}export{kt as component};
